﻿; ----- PaintGraphic2SupportProgram -----
; Ver.1.7
; by Junya Renno 


#SingleInstance force

;---------------- 初期設定 ------------------
SetWinDelay, 10
SetBatchLines, -1
CoordMode, Pixel, Screen
CoordMode, Mouse, Screen

pushFlag = 1
brushMax = 100

Mem = 1
MemMax = 3
WinMem1 = 0
WinMem2 = 0
WinMem3 = 0

IniRead, PFolder, pg2Support.ini, PictureFolderPath, PFolder

palFilePath:=object()
PFileList =
Loop, %PFolder%\*.bmp
{
	PFileList = %PFileList%%A_LoopFileName%|
}
Sort, PFileList ,D|
Loop, parse, PFileList, |
{
	if A_LoopField =  ; Ignore the blank item at the end of the list.
		continue
	palFilePath[A_index] := A_LoopField
}
PFileList := RegExReplace(PFileList,"\|","||","",1)
StartPal := palFilePath[1]
sendColorType=HSL

Loop,10
{
	IniRead, Tool%A_index%, pg2Support.ini, CustomTools, Ctool%A_index%
	StringLeft, Tool%A_index%_1, Tool%A_index%, 1 
	StringRight, Tool%A_index%_2, Tool%A_index%, 1
	Tool%A_index%_2 += 7
}

Gosub,ReadWindow

Gosub,ReadColors

myFunc := RegisterCallback("WinActivateHandler")

myHook := DllCall("SetWinEventHook"
, "UInt", 0x00000003 ; eventMin      : EVENT_SYSTEM_FOREGROUND
, "UInt", 0x00000003 ; eventMax      : 
, "UInt", 0          ; hModule       : self
, "UInt", myFunc     ; hWinEventProc : 
, "UInt", 0          ; idProcess     : All process
, "UInt", 0          ; idThread      : All threads
, "UInt", 0x0003     ; dwFlags       : WINEVENT_SKIPOWNTHREAD | WINEVENT_SKIPOWNPROCESS
, "UInt")

;-------------- ツールボックスから情報取り込み -------------------
ControlGetText, BSize , Edit1, PanelBaseFrame
if BSize > %brushMax%
	Bsize := brushMax

Gosub,ToolGroupGet
pushFlag = 1
Gosub,ToolBoxGet
pushFlag = 1

;---------------------------------------------------
Gui,+AlwaysOnTop +toolwindow
Gui, Margin,4,4
Gui,Font,s12
Gui,Margin,0,0
Gui,Add,Picture, x0 y+4 w28 h28 vTool1 gSetTool1 ,tool_icons\icon_%Tool1%.png
Gui,Add,Picture, x+0 w28 h28 vTool2 gSetTool2 ,tool_icons\icon_%Tool2%.png
Gui,Add,Picture, x0 y+0 w28 h28 vTool3 gSetTool3 ,tool_icons\icon_%Tool3%.png
Gui,Add,Picture, x+0 w28 h28 vTool4 gSetTool4 ,tool_icons\icon_%Tool4%.png
Gui,Add,Picture, x0 y+0 w28 h28 vTool5 gSetTool5 ,tool_icons\icon_%Tool5%.png
Gui,Add,Picture, x+0 w28 h28 vTool6 gSetTool6 ,tool_icons\icon_%Tool6%.png
Gui,Add,Picture, x0 y+0 w28 h28 vTool7 gSetTool7 ,tool_icons\icon_%Tool7%.png
Gui,Add,Picture, x+0 w28 h28 vTool8 gSetTool8 ,tool_icons\icon_%Tool8%.png
Gui,Add,Picture, x0 y+0 w28 h28 vTool9 gSetTool9 ,tool_icons\icon_%Tool9%.png
Gui,Add,Picture, x+0 w28 h28 vTool10 gSetTool10 ,tool_icons\icon_%Tool10%.png
Gui,Add,text  ,x0 Y+0,Memory
Gui,Add,Button  ,x0 Y+1 w18 h20 vWinMem1 gSetMemory1, -
Gui,Add,Button  ,x+0 w18 h20 vWinMem2 gSetMemory2, -
Gui,Add,Button  ,x+0 w18 h20 vWinMem3 gSetMemory3, -
Gui,Add,text  ,x0 Y+0,Macro
Gui,Font,s9
Gui,Add,Button  ,x0 Y+1 w56 h20 gBunkiMacroFile1, Group1
Gui,Add,Button  ,x0 y+0 w56 h20 gBunkiMacroFile2, Group2
Gui,Add,Button  ,x0 Y+0 w56 h20 gBunkiMacroFile3, Group3
Gui,Font,s12
Gui,Add,Button  ,x0 y+4 w56  gExitPg2Support, 終了

Gosub,ToggleWindow

;---------------  Window2作成  ---------------------
Gui,2:+AlwaysOnTop +toolwindow
Gui,2:Margin,0,0

Gui,2:Add, ListView, x4 y+4 h14 w14 ReadOnly 0x4000 +Background%ColorMemory1% vColorMemory1 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory2% vColorMemory2 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory3% vColorMemory3 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory4% vColorMemory4 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory5% vColorMemory5 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory6% vColorMemory6 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory7% vColorMemory7 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory8% vColorMemory8 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory9% vColorMemory9 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory10% vColorMemory10 gColorKeep AltSubmit
Gui,2:Add, ListView, x4 y+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory11% vColorMemory11 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory12% vColorMemory12 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory13% vColorMemory13 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory14% vColorMemory14 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory15% vColorMemory15 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory16% vColorMemory16 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory17% vColorMemory17 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory18% vColorMemory18 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory19% vColorMemory19 gColorKeep AltSubmit
Gui,2:Add, ListView, x+1 h14 w14 ReadOnly 0x4000 +Background%ColorMemory20% vColorMemory20 gColorKeep AltSubmit
Gui,2:Add,Button,x+13 y+-24 w56 gClearColor,クリア
Gui,2:Add,Picture,x2 y+4 w220,tool_icons/line.bmp

Gui,2:Add, ListView, x4 y+3 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor1 gColorTipCheck AltSubmit
Gui,2:Add, ListView, x+2 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor4 gColorTipCheck AltSubmit
Gui,2:Add, ListView, x+2 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor5 gColorTipCheck AltSubmit
Gui,2:Add, ListView, x+2 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor2 gColorTipCheck AltSubmit
Gui,2:Add, ListView, x+2 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor6 gColorTipCheck AltSubmit
Gui,2:Add, ListView, x+2 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor7 gColorTipCheck AltSubmit
Gui,2:Add, ListView, x+2 h20 w20 ReadOnly 0x4000 +Background000000 vPalColor3 gColorTipCheck AltSubmit
Gui,2:Add,Button,x+10 w56 gMixColor,混合
Gui,2:Add,Picture,x2 y+2 w220,tool_icons/line.bmp

Gui,2:Add, ListView, x4 y+3 h18 w18 ReadOnly 0x4000 +Background000000 gColorKeep vColorMemory21 AltSubmit
Gui,2:Add,Edit, x+4 w160 vHexColor ReadOnly,#000000
Gui,2:Add,Picture,x2 y+2 w220,tool_icons/line.bmp

Gui,2:Add,DropDownList ,x0 y+3 w164 gChangePallete vPfileNames, %PFileList%
Gui,2:Add,DropDownList , x+2 w56 gChangeColorType vColorType, HSL||HSV|RGB
Gui,2:Add,Picture, x0 w224 h310 vMyPal gGetColor ,pal_images/%StartPal%

;---------------  Window3作成  ---------------------
Gui,3:+AlwaysOnTop +toolwindow
Gui,3:Margin,2,3
Gui,3:Font,S12
Gui,3:Add,Text  ,x8 y+0 w120, サイズ計算
Gui,3:Add,Text	 ,x0 y+4  w120 vSetStatus, X : 0 - Y : 0

;---------------  Window4作成  ---------------------
Gui,4:+AlwaysOnTop +toolwindow 
Gui,4: Add, Text,, 実行するファイルを選んでください。
Gui,4: Font,s11
Gui,4: Add, ListBox, vMyListBox gMyListBox w400 r10
Gui,4: Add, Button, Default, OK
Gui,4:Add , Button,x+20,キャンセル



; -------------- タスクトレイのメニュー設定 -----------------
Menu, TRAY,Tip,pg2Support
Menu, TRAY,NoStandard
Menu, TRAY,Add,キー説明,ShowKeyPg2Support
Menu, TRAY,Add,再読み込み,ReloadPg2Support
Menu, TRAY,Add,一時停止,SuspendPg2Support
Menu, TRAY,Add,終了,ExitPg2Support
Menu, TRAY,Icon,,,1

;-----------------  キーリマップ部分  -----------------------
#IfWinActive,Paintgraphic2,MenuBar



SPACE::Gosub,PanTool
SPACE up::Gosub,ToolBoxSet

WheelDown::
	if (IME_GET() = 1)
		IME_SET(0)
	Send,{numpadSub}
return
WheelUp::
	if (IME_GET() = 1)
		IME_SET(0)
	Send,{numpadAdd}
return

numpad0::Gosub,ToggleWindow2
numpadDot::Gosub,ToggleWindow
numpadDiv::Gosub,ToggleWindow4
;numpadDiv::Gosub,ColorModeCheck

numpad6::Gosub,pix12
numpad6 up::pushFlag=1
numpad4::Gosub,pix13
numpad4 up::pushFlag=1

numpad1::
	Mem = 1
	Gosub,MemoryWin
return

numpad2::
	Mem = 2
	Gosub,MemoryWin
return

numpad3::
	Mem = 3
	Gosub,MemoryWin
return


PrintScreen::Send,{PRINTSCREEN}^u{ESC}
!PrintScreen::Send,!{PRINTSCREEN}^u{ESC}

~RButton & WheelDown::MouseClick, WheelDown, , , 2
RButton & WheelUp::MouseClick, WheelUp, , , 2

^Right::WinScroll(1,-1)
^Up::WinScroll(-1,0)
^Left::WinScroll(0,-1)
^Down::WinScroll(-1,1)

+RButton::
	MouseGetPos, X, Y
	PixelGetColor, color, %X%, %Y% ,RGB
	r := SplitRgb_r(color)
	g := SplitRgb_g(color)
	b := SplitRgb_b(color)
	ColorMemory21 = %color%

	PutHexColor(color)
	StringReplace,color,color,0x,#
	Clipboard = %color%	
	ClipWait, 1
	Tooltip, %color% : r=%r% g=%g% b=%b%
	Sleep, 1000

	Tooltip,
return

+ESC::ExitApp

Exit

;--------------- 以降サブルーチン -------------------------



;------------------- カラーモードチェック -----------------------
ColorModeCheck:
	WinGetPos, X, Y,,, PanelBaseFrame
lastColorMode = %colorMode%
;rgb
			PixelGetColor, checkColorMode1, X+176, y+439
;hsv
			PixelGetColor, checkColorMode2, X+194, y+439
;gray
			PixelGetColor, checkColorMode3, X+196, y+442
;hsl
			PixelGetColor, checkColorMode4, X+179, y+442
			
	if checkColorMode1 = 0x000000
		colorMode = RGB
	else if checkColorMode2 = 0x000000
		colorMode = HSV
	else if checkColorMode3 = 0x000000
		colorMode = GRAY
	else if checkColorMode4 = 0x000000
		colorMode = HSL
	else 
		colorMode = %lastColorMode%
	SetColorMode(colorMode)
return

;colorModeButton
SetColorMode(mode){
	;HSL||HSV|RGB
	if mode=HSL
		GuiControl,Choose,ColorType,|1
	if mode=HSV
		GuiControl,Choose,ColorType,|2
	if mode=RGB
		GuiControl,Choose,ColorType,|3
}

;ボタンの分岐
SetMemory1:
	Mem= 1
	Gosub,SetMemory
return

SetMemory2:
	Mem= 2
	Gosub,SetMemory
return

SetMemory3:
	Mem= 3
	Gosub,SetMemory
return

SetMemory:
	if (Mem>0 && Mem<=MemMax)
	{
		if WinMem%Mem% = 1
		{
		mZoom := mZoom%Mem%
		ctrl := ctrl%Mem%
		hMin := hMin%Mem%
		hMax := hMax%Mem%
		hPos := hPos%Mem%
		vMin := vMin%Mem%
		vMax := vMax%Mem%
		vPos := vPos%Mem%
		Gosub,SetMemoryWin
		}
	}	
return
;--------------- カラーメモリ消去 --------------------
ClearColor:
	loop,20
	{
		GuiControl,2: +BackGround000000,ColorMemory%A_Index%
		ColorMemory%A_Index% = 000000
	}
return
;--------------- ウィンドウ記憶 --------------- 
MemoryWin:
	ControlGetText, mZoom, Edit1,Paintgraphic2,MenuBar
	ControlGet, ctrl,Hwnd,,,A
	GetScrollInfoAll(ctrl,0, hMin,hMax,hPage,hPos,hTrakpos)
	GetScrollInfoAll(ctrl,1, vMin,vMax,vPage,vPos,vTrakpos)	

	Tooltip,マーキング　%Mem%`n表示 %mZoom%`%`n水平 %hMin% ～ %hMax% ：位置 %hPos%`n垂直 %vMin% ～ %vMax% ：位置 %vPos%
	if (Mem>0 && Mem<=MemMax)
	{
		mZoom%Mem% := mZoom
		ctrl%Mem% := ctrl
		hMin%Mem% := hMin
		hMax%Mem% := hMax
		hPos%Mem% := hPos
		vMin%Mem% := vMin
		vMax%Mem% := vMax
		vPos%Mem% := vPos
		WinMem%Mem% := 1
		GuiControl,, WinMem%Mem%, %Mem%
	}
	Sleep, 2000
	Tooltip,	
return

;--------------- ウィンドウ再現 --------------- 
SetMemoryWin:
	if mZoom > 0
	{
		ControlClick,Edit1,Paintgraphic2,MenuBar,L
		ControlSetText,Edit1,%mZoom%,Paintgraphic2,MenuBar
		
		ControlSend,Edit1,{enter},Paintgraphic2,MenuBar
		if ctrl=
			return
		else
		{
;	PostMessage, 0x114,  0x5 | hPos<<16,0,,ahk_id %ctrl%
	PostMessage, 0x114,  0x4 | hPos<<16,0,,ahk_id %ctrl%
	PostMessage, 0x114, 0x8,0,,ahk_id %ctrl%
;	PostMessage, 0x115,  0x5 | vPos<<16,0,,ahk_id %ctrl%
	PostMessage, 0x115,  0x4 | vPos<<16,0,,ahk_id %ctrl%
	PostMessage, 0x115, 0x8,0,,ahk_id %ctrl%
		
		}
	}
return

;--------------------- マクロ実行 --------------------
BunkiMacroFile1:
	MacroPath = macro1
	Gosub,ChooseMacroFile
return

BunkiMacroFile2:
	MacroPath = macro2
	Gosub,ChooseMacroFile
return

BunkiMacroFile3:
	MacroPath = macro3
	Gosub,ChooseMacroFile
return

ChooseMacroFile:
	Guicontrol,4:,MyListBox,|
	Loop, macro\%MacroPath%\*.* 
	{
		GuiControl,4:, MyListBox,%A_LoopFileName%
	}
	WinGetPos, W1x, W1y, , , カスタムツール
	W4x := W1x - 200
	W4y := W1y + 200
	Gui,4:Show,X%W4x% Y%W4y%,Macro
return

MyListBox:
if A_GuiControlEvent <> DoubleClick
	return

4ButtonOK:
GuiControlGet, MyListBox  
Run, macro\%MacroPath%\%MyListBox%,, UseErrorLevel
if ErrorLevel = ERROR
	MsgBox Could not launch the specified file.  Perhaps it is not associated with anything.
	Gui,4:Hide
return

4Buttonキャンセル:
	Gui,4:Hide
return


GetColorCode:
return

scColorR1:
return
;--------------- 色混ぜ ----------------------

MixColor:
	WinActivate,Paintgraphic2,MenuBar
	WinGetPos, X, Y,,, PanelBaseFrame
	PixelGetColor, pColor1, X+10, y+350,RGB
	GuiControl,+BackGround%pColor1%,PalColor1
	PixelGetColor, pColor3, X+33, y+360,RGB
	GuiControl,+BackGround%pColor3%,PalColor3

	red_1 := SplitRgb_r(pColor1)
	red_2 := SplitRgb_r(pColor3)
	green_1 := SplitRgb_g(pColor1)
	green_2 := SplitRgb_g(pColor3)
	blue_1 := SplitRgb_b(pColor1)
	blue_2 := SplitRgb_b(pColor3)

	pColor2 := MixColorRGB(red_1,red_2,green_1,green_2,blue_1,blue_2,0.5,0.5)
	GuiControl,+BackGround%pColor2%,PalColor2

	pColor4 := MixColorRGB(red_1,red_2,green_1,green_2,blue_1,blue_2,0.9,0.1)
	GuiControl,+BackGround%pColor4%,PalColor4
	
	pColor5 := MixColorRGB(red_1,red_2,green_1,green_2,blue_1,blue_2,0.7,0.3)
	GuiControl,+BackGround%pColor5%,PalColor5

	pColor6 := MixColorRGB(red_1,red_2,green_1,green_2,blue_1,blue_2,0.3,0.7)
	GuiControl,+BackGround%pColor6%,PalColor6
	
	pColor7 := MixColorRGB(red_1,red_2,green_1,green_2,blue_1,blue_2,0.1,0.9)
	GuiControl,+BackGround%pColor7%,PalColor7

return

;--------------------- 色記憶 ------------------------------------
ColorKeep:
		if A_GuiEvent=Normal
	{
		MouseGetPos, X, Y
		PixelGetColor, color, %X%, %Y% ,RGB
		if color=0x000000 
		{
			WinActivate,Paintgraphic2,MenuBar
			WinGetPos, X, Y,,, PanelBaseFrame
			PixelGetColor, pColor1, X+20, y+320,RGB 
			GuiControl,+BackGround%pColor1%,%A_GuiControl%
			%A_GuiControl% = %pColor1%
			PutHexColor(pColor1)

		} else {
			Gosub,getColor
		}
	}
return
	
;---------------------------------------------------
PutHexColor(color){
	GuiControl,2: +BackGround%color%,ColorMemory21	
	StringReplace,color,color,0x,#
	Guicontrol,2:,HexColor,%color%	
}
;--------------- mix --------------------------------
MixColorRGB(r1,r2,g1,g2,b1,b2,p1,p2){
	r3 := r1 * p1 + r2 * p2
	g3 := g1 * p1 + g2 * p2
	b3 := b1 * p1 + b2 * p2
	return MakeHexNum(r3)MakeHexNum(g3)MakeHexNum(b3)
}
;--------------- hex change -------------------------
MakeHexNum(Num){

	Num := floor(Num + 0.5)
	if Num > 255
		Num = 255
	if Num < 0
		Num = 0
	SetFormat, integer, hex
	Num+=0
	StringReplace,Num,Num,0x,,
	Num = 0%Num% 
	StringRight,Num,Num,2
	SetFormat,integer,d
	return Num
}
;--------------  colortips用処理 --------------------
ColorTipCheck:
	if A_GuiEvent=Normal
		gosub,getColor
return
;--------------- トリミングサイズ計算 --------------- 
GetStatus:
loop
{
	IfWinNotExist, トリミング,,トリミングサイズ
	break
	
	WinGetText, RetrievedText,トリミング,,トリミングサイズ
	StringReplace, rText,RetrievedText,`r`n,@, All
	StringSplit, TrimText, rText,@,
	xSize := TrimText12 - TrimText8 + 1
	ySize := TrimText14 - TrimText10 + 1
	GuiControl, 3:Text, SetStatus , X : %xSize% - Y : %ySize%
	sleep,100
}
return

;--------------- パニングツール ---------------
PanTool:
	Gosub,ToolBoxGet
	Send,^!p	
return

;--------------- ツールボタンの色を記憶 ---------------
ToolBoxGet:
	if pushFlag = 1
	{
		WinGetPos, X, Y,,, PanelBaseFrame
		Loop,9
		{
			lc = %A_index%
			buttonX := lc*23-19
			PixelGetColor, tools%A_index%, X+buttonX, y+81
			if tools%A_index% = 0xA8A8A8
			{
				buttonNum = %A_index%
;				buttonNum += 7
				break
			}
		}
		pushFlag = 0
	}	
return

;--------------- グループボタンの色を記憶 ---------------
ToolGroupGet:
	if pushFlag = 1
	{
		WinGetPos, X, Y,,, PanelBaseFrame
		Loop,7
		{
			lc = %A_index%
			buttonX := lc*30-25
			PixelGetColor, groups%A_index%, X+buttonX, y+48
			if groups%A_index% = 0xFFFFFF
			{
;				groupButton = AfxWnd42s%A_index%
				groupNum = %A_index%
				break
			}
		}
		pushFlag = 0
	}	
return

;------------------- カスタムパレット用処理 -------------------

SetTool(ByRef ChangeTool,ByRef T1,ByRef T2){
	global groupButton,groupNum,buttonNum,pushFlag,Selected
	if ChangeTool = 00
	{
		Gosub,ToolGroupGet
		pushFlag = 1
		Gosub,ToolBoxGet
		pushFlag = 1
		ChangeTool = %groupNum%%buttonNum%
		T1 = %groupNum%
		T2 = %buttonNum%
		T2 += 7
		GuiControl,, ChangeTool, tool_icons\icon_%ChangeTool%.png
	}
	else
	{
		ControlClick, AfxWnd42s%T1%,  PanelBaseFrame,,LEFT
		ControlClick, button%T2%,  PanelBaseFrame,,LEFT
		GuiControl,, ChangeTool, tool_selected\pdicon_%ChangeTool%.png
		sleep 100
		GuiControl,, ChangeTool, tool_icons\icon_%ChangeTool%.png
	}
}

;ボタン処理
SetTool1:
	SetTool(Tool1,Tool1_1,Tool1_2)
return

SetTool2:
	SetTool(Tool2,Tool2_1,Tool2_2)
return

SetTool3:
	SetTool(Tool3,Tool3_1,Tool3_2)
return

SetTool4:
	SetTool(Tool4,Tool4_1,Tool4_2)
return

SetTool5:
	SetTool(Tool5,Tool5_1,Tool5_2)
return

SetTool6:
	SetTool(Tool6,Tool6_1,Tool6_2)
return

SetTool7:
	SetTool(Tool7,Tool7_1,Tool7_2)
return

SetTool8:
	SetTool(Tool8,Tool8_1,Tool8_2)
return

SetTool9:
	SetTool(Tool9,Tool9_1,Tool9_2)
return

SetTool10:
	SetTool(Tool10,Tool10_1,Tool10_2)
return
;------------------- 消去 -------------------------
ClearTools:
	Loop,10
	{
		GuiControl,, Tool%A_index%, tool_icons\icon_00.png
		Tool%A_index% = 00
	}
return

;------------------ ツールボタン操作 --------------------
ToolBoxSet:
	tb := buttonNum + 7
	ControlClick,  button%tb%,  PanelBaseFrame,,LEFT
	pushFlag = 1
return

;---------------------- Window表示/非表示 -----------------------
ToggleWindow:
	IfWinExist ,カスタムツール
	{
;		if W1Switch
			Gui,Show,Hide
	} else 
	{
	Gosub,ReadWindow
	if W1x =
	{
		MouseGetPos, Wx, Wy
		W1x = %Wx%
		W1y = %Wy%
		W1x -= 20
	}
	Gui,Show,X%W1x% Y%W1y%,カスタムツール
	WinActivate,Paintgraphic2,MenuBar
	}
return

ToggleWindow2:
	IfWinExist ,カスタムパレット
	{
;		if W2Switch
			Gui,2:Show,Hide
	} else 
	{
	Gosub,ReadWindow
	if W2x =
	{
		MouseGetPos, Wx, Wy
		W2x = %Wx%
		W2y = %Wy%
		W2x -= 20
	}
	Gui,2:Show,X%W2x% Y%W2y%,カスタムパレット
	WinActivate,Paintgraphic2,MenuBar
	}
return

ToggleWindow3:
	IfWinExist ,トリミングサイズ,サイズ計算
	{
			Gui,3:Show,Hide
	} else 
	{
	Gosub,ReadWindow
	if W3x =
	{
		MouseGetPos, Wx, Wy
		W3x := Wx-20
		W3y = %Wy%
	}
	Gui,3:Show,X%W3x% Y%W3y%,トリミングサイズ
	WinActivate,Paintgraphic2,MenuBar
	}
return

ToggleWindow4:
	IfWinExist ,Macro
	{
		Gui,4:Show,Hide
	} else 
	{
	Gui,4:Show,X%W1x% Y%W1y%,Macro
	WinActivate,Paintgraphic2,MenuBar
	}
return
;----------------------- ブラシサイズ変更 ---------------------------

pix12:
	if pushFlag = 1
	{ 
		BSize++
		if BSize>%brushMax%
			BSize:=brushMax
		ControlSend,Edit1,{bs 3}{del 3}%BSize%{enter}, PanelBaseFrame
		ToolTip, %BSize%
		SetTimer, RemoveToolTip, 750
		pushFlag = 0
	}
return

pix13:
	if pushFlag = 1
	{ 
		BSize--
		if BSize=0
			BSize=1
		ControlSend,Edit1,{bs 3}{del 3}%BSize%{enter}, PanelBaseFrame
		ToolTip, %BSize%
		SetTimer, RemoveToolTip, 750
		pushFlag=0
	}
return


RemoveToolTip:
	SetTimer, RemoveToolTip, Off
	ToolTip
return
;-------------------------- RGB分解 ---------------------------------
SplitRgb_r(color){
	StringMid, r,color,3,2
	r = 0x%r%
	r+=0
	return %r%
}

SplitRgb_g(color){
	StringMid, g,color,5,2
	g = 0x%g%
	g+=0
	return %g%
}

SplitRgb_b(color){
	StringRight, b, color, 2
	b = 0x%b%
	b+=0
	return %b%
}


;--------------------------  色を送信 -------------------------------
getColor:
	MouseGetPos, X, Y
	PixelGetColor, color, %X%, %Y% ,RGB

b := color & 0xFF
g := (color >> 8) & 0xFF
r := (color >> 16)

	PutHexColor(color)
	Gosub,ColorModeCheck
	
	
	if colorMode=HSL
		RgbToHsl(r,g,b)
	 else
	if colorMode=RGB
		sendRgb(r,g,b)
	else
	if colorMode=HSV
		RgbToHsv(r,g,b)

return

;----------------------------- RGB ------------------------------
SendRgb(r,g,b){
	ControlSend,Edit28,{del 3}%r%, PanelBaseFrame
	ControlSend,Edit29,{del 3}%g%, PanelBaseFrame
	ControlSend,Edit30,{del 3}%b%{enter}, PanelBaseFrame
}

;----------------------------- RGB->HSL ------------------------------
RgbToHsl(R,G,B){
	R+=0.0
	G+=0.0
	B+=0.0
	
	R:=R/255
	G:=G/255
	B:=B/255


	lMax+=0.0
  lMin+=0.0
  
	If R > %G%
    	{
    	lMax := R
    	lMin := G
    	}
  	Else
    	{
		lMax := G
		lMin := R
		}

	If B > %lMax%
		lMax := B
	Else If B < %lMin%
    	lMin := B
	Luminance := (lMax + lMin) / 2.0
	if lMax = %lMin%
	{
		Saturation = 0
		Hue=0
	}else
	{
		if Luminance <= 0.5
			Saturation := ((lMax - lMin )/(lMax + lMin))+ 0.0
		else 
			Saturation := (lMax - lMin )/(2.0 - lMax - lMin)

		Cr+=0.0
		Cg+=0.0
		Cb+=0.0

		Cr := (lMax - R) / (lMax - lMin)
		Cg := (lMax - G) / (lMax - lMin)
		Cb := (lMax - B) / (lMax - lMin)

		if lMax = %R%
			Hue := Cb -Cg + 0.0
		if lMax = %G%
			Hue := 2.0 + Cr -Cb
		if lMax = %B%
			Hue := 4.0 + Cg -Cr

		Hue := 60.0 * Hue
		if Hue < 0.0
			Hue := Hue + 360.0
	}
	Ls:=round(Luminance*100)
	Hs:=round(Hue+0.0001)
	Ss:=round(Saturation*100)

	ControlSend,Edit28,{del 3}{bs 3}%Hs%, PanelBaseFrame
	ControlSend,Edit30,{del 3}{bs 3}%Ss%, PanelBaseFrame
	ControlSend,Edit29,{del 3}{bs 3}%Ls%{enter}, PanelBaseFrame
}

;----------------------------- RGB->HSV ------------------------------
RgbToHsv(R,G,B){
	R+=0.0
	G+=0.0
	B+=0.0
	
	R:=R/255
	G:=G/255
	B:=B/255

	lMax+=0.0
  lMin+=0.0

	If R > %G%
    	{
    	lMax := R
    	lMin := G
    	}
  	Else
    	{
		lMax := G
		lMin := R
		}

	If B > %lMax%
		lMax := B
	Else If B < %lMin%
    	lMin := B
	Value := lMax
	if Value=0
	{
		Saturation = 0
		Hue=0
	}else
	{
		Saturation := (lMax - lMin )/lMax
		
		Cr+=0.0
		Cg+=0.0
		Cb+=0.0
		
		Cr := (lMax - R) / (lMax - lMin)
		Cg := (lMax - G) / (lMax - lMin)
		Cb := (lMax - B) / (lMax - lMin)

		if lMax = %R%
			Hue := Cb -Cg + 0.0
		if lMax = %G%
			Hue := 2.0 + Cr -Cb
		if lMax = %B%
			Hue := 4.0 + Cg -Cr

		Hue := 60.0 * Hue
		if Hue < 0.0 
			Hue := Hue + 360.0
	}
	Vs:=floor(Value*100)
	Hs:=floor(Hue+0.0001)
	Ss:=floor(Saturation*100)

	ControlSend,Edit28,{del 3}{bs 3}%Hs%, PanelBaseFrame
	ControlSend,Edit29,{del 3}{bs 3}%Ss%, PanelBaseFrame
	ControlSend,Edit30,{del 3}{bs 3}%Vs%{enter}, PanelBaseFrame
}

;------------------------------ パレット切り替え ---------------------------
ChangePallete:
	WinActivate,Paintgraphic2,MenuBar
	GuiControlGet,pName,2:,PfileNames
	GuiControl,2:,MyPal,pal_images/%pName%
return

;----------------------- カラースペース切り替え -----------------------------
ChangeColorType:
	GuiControlGet,selected,2:,ColorType	
	sendColorType=%selected%
	colorMode = %selected%
return

;------------------------------ パレットメニュー ---------------------------
PMenu:
	if sName = 消去
		Gosub,ClearTools
	if sName = 保存
		Gosub,SaveTools
	if sName = 読込
		Gosub,ReadTools
	if sName = 終了
		Gosub,ExitPg2Support
return

;-------------------------- キー表示 ---------------------------------------
ShowKeyPg2Support:
	Msgbox,ズーム拡大／縮小　　　　　：マウスホイール`nドラッグによるスクロール　：スペースキー`nパレット表示／非表示　　　：テンキ－0／.`nウィンドウ記憶　　　　　　：テンキー1 2 3`nブラシサイズ増減　　　　　：テンキー4／6`n色をクリップボードにコピー：Shift + 右クリック
return

;---------------------------
GuiContextMenu:
	IfInString,A_GuiControl,Tool
	{
	GuiControl,, %A_GuiControl%, tool_icons\icon_00.png
	%A_GuiControl% = 00
	}
	IfInString,A_GuiControl,WinMem
	{
		GuiControl,, %A_GuiControl%, -
		%A_GuiControl% = 0
	}

return

2GuiContextMenu:
	IfInString,A_GuiControl,ColorMemory
	{
		GuiControl,+BackGround000000,%A_GuiControl%
	}
	
return
;--------------------------- 終了処理 --------------------------------------
ExitPg2Support:
	Gosub,SaveTools
	Gosub,SaveWindow
	Gosub,SaveColors
	msgbox,終了します
	ExitApp
return
;---------------------------- 	ツール保存・読み込み ----------------------------------
SaveTools:
	Loop,10
	{
		ic := Tool%A_index%
		IniWrite, %ic%, pg2Support.ini, CustomTools, Ctool%A_index%
	}
return

ReadTools:
	Loop,10
	{
		IniRead, Tool%A_index%, pg2Support.ini, CustomTools, Ctool%A_index%
		ic := Tool%A_index%
		GuiControl,, Tool%A_index%, tool_icons\icon_%ic%.png
	}
return
;-------------------------------- 位置保存・読み込み ----------------------------------
SaveWindow:
	WinGetPos,W1x,W1y,,,カスタムツール
	WinGetPos,W2x,W2y,,,カスタムパレット
	IniWrite, %W1x%, pg2Support.ini, WindowPos, W1x
	IniWrite, %W1y%, pg2Support.ini, WindowPos, W1y
	IniWrite, %W2x%, pg2Support.ini, WindowPos, W2x
	IniWrite, %W2y%, pg2Support.ini, WindowPos, W2y
return

ReadWindow:
	IniRead, W1x, pg2Support.ini, WindowPos, W1x
	IniRead, W1y, pg2Support.ini, WindowPos, W1y
	IniRead, W2x, pg2Support.ini, WindowPos, W2x
	IniRead, W2y, pg2Support.ini, WindowPos, W2y
return
;-------------------------------- カラー保存、読み込み --------------------------------
SaveColors:
	Loop,20
	{
		drgb := ColorMemory%A_Index%
		IniWrite, %drgb%, pg2Support.ini, ColorMemory, RGB%A_Index%
	}
return
	
ReadColors:
	Loop,20
	{
		IniRead, ColorMemory%A_Index%, pg2Support.ini, ColorMemory, RGB%A_Index%
		drgb := ColorMemory%A_Index%
		Guicontrol, +Background%drgb%,ColorMemory%A_Index%
	}
	
return
	
;---------------------------- 再読み込み ------------------------------------
ReloadPg2Support:
	Reload
return

;--------------------------- 一時停止 ---------------------------------------
SuspendPg2Support:
	Suspend
return

; --------------------------- ウィンドウ消す ---------------------------------
GuiClose:
	WinGetPos,W1x,W1y,,,カスタムツール
	Gosub,SaveWindow
	Gui,Hide
return

2GuiClose:
	WinGetPos,W2x,W2y,,,カスタムパレット
	Gosub,SaveWindow
	Gui,2:Hide
return

;
; type
;  SB_HORZ=0, SB_VERT=1, SB_CTRL=2
;
GetScrollInfoAll(hwnd, type, ByRef nMin="", ByRef nMax="", ByRef nPage="", ByRef nPos="", ByRef nTrackPos="") {
		VarSetCapacity(SCROLLINFO, 7*4, 0x00)
		NumPut(28,   SCROLLINFO, 0, "Int")
		NumPut(0x17, SCROLLINFO, 4, "Int") ; SIF_RANGE & SIF_PAGE & SIF_POS & SIF_TRACKPOS = 0x17
		nMin:="", nMax:="", nPage:="", nPos:="", nTrackPos:=""
		if (!DllCall("user32.dll\GetScrollInfo", "UInt", hwnd, "Int",type, "Ptr", &SCROLLINFO, "Int"))
			Return false
		nMin      := NumGet(SCROLLINFO,  8, "Int")
		nMax      := NumGet(SCROLLINFO, 12, "Int")
		nPage     := NumGet(SCROLLINFO, 16, "Int")
		nPos      := NumGet(SCROLLINFO, 20, "Int")
		nTrackPos := NumGet(SCROLLINFO, 24, "Int")
		Return true
}

;ウィンドウを捕まえるフック関数
WinActivateHandler(hWinEventHook, event, hwnd, idObject, idChild, thread, time) {
	sleep 200
	WinGetTitle, title, ahk_id %hwnd%
	if title=開く
	{
		Control,ChooseString,すべてのファイル形式,ComboBox2,開く
	}
	else
	if title=トリミング
	{
		IfWinNotExist ,トリミングサイズ,サイズ計算
		{
			WinGetPos,W3x,W3y,,,ahk_id %hwnd%
			W3x := W3x + 410
			W3y := W3y + 10
			Gui,3:Show,X%W3x% Y%W3y%,トリミングサイズ
			Sleep 100
			Gosub,GetStatus
		}
	} else {
		Gui,3:Show,Hide
	}
	
}

;スクロールのためにメッセージを投げる
WinScroll(x,y){
	ControlGet, ctrl,Hwnd,,,A
	if (x=0 || x=1)
	{
		PostMessage, 0x114,  x ,0,,ahk_id %ctrl%
		PostMessage, 0x114, 0x8,0,,ahk_id %ctrl%
	}
	if (y=0 || y=1)
	{
		PostMessage, 0x115,  y ,0,,ahk_id %ctrl%
		PostMessage, 0x115, 0x8,0,,ahk_id %ctrl%
	}
}

;------------ 以降IME.ahkより拝借。感謝 -----------------

IME_GET(WinTitle="A")  {
	ControlGet,hwnd,HWND,,,%WinTitle%
	if	(WinActive(WinTitle))	{
		ptrSize := !A_PtrSize ? 4 : A_PtrSize
	    VarSetCapacity(stGTI, cbSize:=4+4+(PtrSize*6)+16, 0)
	    NumPut(cbSize, stGTI,  0, "UInt")   ;	DWORD   cbSize;
		hwnd := DllCall("GetGUIThreadInfo", Uint,0, Uint,&stGTI)
	             ? NumGet(stGTI,8+PtrSize,"UInt") : hwnd
	}

    return DllCall("SendMessage"
          , UInt, DllCall("imm32\ImmGetDefaultIMEWnd", Uint,hwnd)
          , UInt, 0x0283  ;Message : WM_IME_CONTROL
          ,  Int, 0x0005  ;wParam  : IMC_GETOPENSTATUS
          ,  Int, 0)      ;lParam  : 0
}

;-----------------------------------------------------------
; IMEの状態をセット
;   SetSts          1:ON / 0:OFF
;   WinTitle="A"    対象Window
;   戻り値          0:成功 / 0以外:失敗
;-----------------------------------------------------------
IME_SET(SetSts, WinTitle="A")    {
	ControlGet,hwnd,HWND,,,%WinTitle%
	if	(WinActive(WinTitle))	{
		ptrSize := !A_PtrSize ? 4 : A_PtrSize
	    VarSetCapacity(stGTI, cbSize:=4+4+(PtrSize*6)+16, 0)
	    NumPut(cbSize, stGTI,  0, "UInt")   ;	DWORD   cbSize;
		hwnd := DllCall("GetGUIThreadInfo", Uint,0, Uint,&stGTI)
	             ? NumGet(stGTI,8+PtrSize,"UInt") : hwnd
	}

    return DllCall("SendMessage"
          , UInt, DllCall("imm32\ImmGetDefaultIMEWnd", Uint,hwnd)
          , UInt, 0x0283  ;Message : WM_IME_CONTROL
          ,  Int, 0x006   ;wParam  : IMC_SETOPENSTATUS
          ,  Int, SetSts) ;lParam  : 0 or 1
}
